leetcode@ [300] Longest Increasing Subsequence (记忆化搜索)

https://leetcode.com/problems/longest-increasing-subsequence/

Given an unsorted array of integers, find the length of longest increasing subsequence.

For example,
Given [10, 9, 2, 5, 3, 7, 101, 18],
The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.

Your algorithm should run in O(n2) complexity.

Follow up: Could you improve it to O(n log n) time complexity?

class Solution {
public:
    int dfs(vector<int>& nums, vector<int> &dp, int v) {
        if(dp[v]) return dp[v];
        if(v == 0) return 0;
        
        int res = -1;
        for(int nv=v-1;nv>=0;--nv) {
            if(nums[nv] >= nums[v]) continue;
            res = max(res, dfs(nums, dp, nv));
        }
        dp[v] = res + 1;
        return dp[v];
    }
    int lengthOfLIS(vector<int>& nums) {
        if(nums.size() == 0 || nums.size() == 1) return nums.size();
        
        vector<int> dp(nums.size(), 0);
        
        int res = -1;
        for(int i=nums.size()-1;i>=0;--i) {
            dp[i] = dfs(nums, dp, i);
            res = max(res, dp[i] + 1);
        }
        
        return res;
    }
};
View Code
原文地址:https://www.cnblogs.com/fu11211129/p/4962032.html